<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2015, Ebenezer Obasi
 * All rights reserved.
 * info@eobai.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
class SMWIDGETS_CMP_Google extends BASE_CLASS_Widget{
	
	public function __construct(BASE_CLASS_WidgetParameter $params) {
		
		parent::__construct();
		
		$userId = $params->additionalParamList['entityId'];
		
		$pageID = SMWIDGETS_BOL_Service::getInstance()->getFieldValue('smwidgets_google_id', $userId);
		$config = OW::getConfig();
		$lang = OW::getLanguage();
		
		if(!empty($pageID)){
			$gScript = '<script src="https://apis.google.com/js/platform.js" async defer></script>';
			OW::getDocument()->appendBody($gScript);
				
			$class = $config->getValue('smwidgets', 'class');
			switch($class){
				case 'person':
					$class = 'g-person';
					$rel ='author';
					break;
				case 'page':
					$class = 'g-page';
					$rel = 'publisher';
					break;
				default:
			}
			$width = $config->getValue('smwidgets', 'data_width');
			$layout = $config->getValue('smwidgets', 'g_data_layout');
			$cover = $config->getValue('smwidgets', 'g_data_showcoverphoto');
			$tagline = $config->getValue('smwidgets', 'g_data_tagline');
			$theme = $config->getValue('smwidgets', 'color_scheme');
			
			$cmp = "
				<div class='$class' data-href='https://plus.google.com/$pageID' data-layout='$layout' data-showcoverphoto='$cover' data-showtagline='$tagline' data-theme='$theme' data-width='$width' data-rel='$rel'> </div>
			";
			$this->assign('cmp', $cmp);
			
		}
		else{
			
			if(SMWIDGETS_BOL_Service::getInstance()->isOwner($userId) && SMWIDGETS_BOL_Service::getInstance()->showBtn()){
				
				$customParam = array(
					'elemId' => 'go_btn',
					'inviteTxt' => $lang->text("smwidgets", "go_btn_nag")
				);
				
				$cmp = new SMWIDGETS_CMP_Button($customParam);
				$this->addComponent('cmp', $cmp);
			}
			else{
			
				if (!$params->customizeMode){
					
					$this->setVisible(false);
					
				}
				$this->assign('cmp', null);
			}
		}
    }
    public static function getStandardSettingValueList() {
        return array(
            self::SETTING_TITLE => OW::getLanguage()->text('smwidgets', 'google_widget_title'),
            self::SETTING_ICON => self::ICON_USER,
            self::SETTING_SHOW_TITLE => true,
            self::SETTING_WRAP_IN_BOX => true
        );
    }

    public static function getAccess() {
        return self::ACCESS_ALL;
    }
}