<?php 
	
	class SMWIDGETS_CMP_Questions extends OW_Component{
		
		public function __construct(){
			
			$showBtn = SMWIDGETS_BOL_Service::getInstance()->showBtn();
			$this->assign('showBtn', $showBtn);
			
			$script = '
				$("#fb_btn, #tw_btn, #go_btn").click(function(){
					var $form_content = $("#smwidgets_form");
					
					window.feedback_form_floatbox = new OW_FloatBox({
						$title: OW.getLanguageText("smwidgets", "floatbox_cap_label"),
						$contents: $form_content,
						icon_class: "ow_ic_mail",
						width: 520
					});
				});
			';
			
			if($showBtn){
				OW::getDocument()->addOnloadScript($script, -9999);
			}
			
			$questionData = BOL_QuestionService::getInstance()->getQuestionData(array( OW::getUser()->getId() ), array( 'smwidgets_twitter_id', 'smwidgets_facebook_id', 'smwidgets_google_id' ));
			
			$lang = OW::getLanguage();
			$userId = OW::getUser()->getId();
		
			$form = new Form('smwidgets_questions');

			$twitter = new TextField('smwidgets_twitter_id');
			$twitter->setLabel($lang->text('base', 'questions_question_smwidgets_twitter_id_label'));
			$twitter->setDescription($lang->text('base', 'questions_question_smwidgets_twitter_id_description'));
			if(!empty($questionData[$userId]['smwidgets_twitter_id'])){
				$twitter->setValue($questionData[$userId]['smwidgets_twitter_id']);
			}
			$form->addElement($twitter);

			$google = new TextField('smwidgets_google_id');
			$google->setLabel($lang->text('base', 'questions_question_smwidgets_google_id_label'));
			$google->setDescription($lang->text('base', 'questions_question_smwidgets_google_id_description'));
			if(!empty($questionData[$userId]['smwidgets_google_id'])){
				$google->setValue($questionData[$userId]['smwidgets_google_id']);
			}
			$form->addElement($google);

			$facebook = new TextField('smwidgets_facebook_id');
			$facebook->setLabel($lang->text('base', 'questions_question_smwidgets_facebook_id_label'));
			$facebook->setDescription($lang->text('base', 'questions_question_smwidgets_facebook_id_description'));
			if(!empty($questionData[$userId]['smwidgets_facebook_id'])){
				$facebook->setValue($questionData[$userId]['smwidgets_facebook_id']);
			}
			$form->addElement($facebook);

			$saveButton = new Submit('save');
			$saveButton->setValue($lang->text('smwidgets', 'save_btn_label'));
			$form->addElement($saveButton);

			$this->addForm($form);

			//Processing form data after submit
			if ( OW::getRequest()->isPost() && $form->isValid($_POST) )
			{
				$data = $form->getValues();

				$questionData = array(
					'twitter'=>$data['smwidgets_twitter_id'],
					'facebook'=>$data['smwidgets_facebook_id'],
					'google'=>$data['smwidgets_google_id']
				);

				BOL_QuestionService::getInstance()->saveQuestionsData($data, OW::getUser()->getId());

				OW::getFeedback()->info($lang->text('smwidgets', 'smwidgets_questions_update_success'));
				OW::getApplication()->redirect(OW::getRequest()->getRequestUri());
			}
			
			$lang->addKeyForJs('smwidgets', 'floatbox_cap_label');
			
		}
		
	}