<?php

/**
 * This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
 * For more information see License.txt in the plugin folder.

 * ---
 * Copyright (c) 2015, Ebenezer Obasi
 * All rights reserved.
 * info@eobai.com.

 * Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

 * This plugin should be bought from the developer. For details contact info@eobasi.com.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

class SMWIDGETS_CTRL_Admin extends ADMIN_CTRL_Abstract
{
	public function __construct() {
	parent::__construct();

		if (OW::getRequest()->isAjax()) {
			return;
		}

		$lang = OW::getLanguage();

		$menu = new BASE_CMP_ContentMenu();
		
		$menuItem = new BASE_MenuItem();
		$menuItem->setKey('facebook');
		$menuItem->setLabel($lang->text('smwidgets', 'smwidgets_admin_facebook'));
		$menuItem->setUrl(OW::getRouter()->urlForRoute('smwidgets_admin_facebook'));
		$menuItem->setIconClass('ow_ic_gear_wheel');
		$menuItem->setOrder(1);
		$menu->addElement($menuItem);
		
		$menuItem = new BASE_MenuItem();
		$menuItem->setKey('twitter');
		$menuItem->setLabel($lang->text('smwidgets', 'smwidgets_admin_twitter'));
		$menuItem->setUrl(OW::getRouter()->urlForRoute('smwidgets_admin_twitter'));
		$menuItem->setIconClass('ow_ic_gear_wheel');
		$menuItem->setOrder(2);
		$menu->addElement($menuItem);

		$menuItem = new BASE_MenuItem();
		$menuItem->setKey('google');
		$menuItem->setLabel($lang->text('smwidgets', 'smwidgets_admin_google'));
		$menuItem->setUrl(OW::getRouter()->urlForRoute('smwidgets_admin_google'));
		$menuItem->setIconClass('ow_ic_gear_wheel');
		$menuItem->setOrder(3);
		$menu->addElement($menuItem);

		$menuItem = new BASE_MenuItem();
		$menuItem->setKey('settings');
		$menuItem->setLabel($lang->text('smwidgets', 'smwidgets_admin_settings'));
		$menuItem->setUrl(OW::getRouter()->urlForRoute('smwidgets_admin_settings'));
		$menuItem->setIconClass('ow_ic_gear_wheel');
		$menuItem->setOrder(4);
		$menu->addElement($menuItem);

		$this->addComponent('menu', $menu);
		$this->menu = $menu;
		
	}

    public function settings()
    {
        $this->setPageTitle(OW::getLanguage()->text('smwidgets', 'smwidget_heading'));

        $form = new Form('smwidgets_settings');
		
		$config = OW::getConfig();
		$lang = OW::getLanguage();
		
		$width = $config->getValue('smwidgets', 'data_width');
		$height = $config->getValue('smwidgets', 'data_height');
		$btn = $config->getValue('smwidgets', 'show_btn');
		$color = $config->getValue('smwidgets', 'color_scheme');
		
		$fieldWidth = new TextField('data_width');
        $fieldWidth->setLabel($lang->text("smwidgets", "data_width_label"));
        $fieldWidth->setDescription($lang->text('smwidgets', 'data_width_desc'));
		$form->addElement($fieldWidth);
		
		$fieldHeight = new TextField('data_height');
        $fieldHeight->setLabel($lang->text("smwidgets", "data_height_label"));
        $fieldHeight->setDescription($lang->text('smwidgets', 'data_height_desc'));
		$form->addElement($fieldHeight);
		
		$fieldBtn = new Selectbox('show_btn');
		$fieldBtn->setLabel($lang->text('smwidgets', 'show_btn_label'));
		$fieldBtn->setDescription($lang->text('smwidgets', 'show_btn_desc'));
		$fieldBtn->setOptions(array('true' => $lang->text('smwidgets', 'admin_option_true'), 'false' => $lang->text('smwidgets', 'admin_option_false')));
		$form->addElement($fieldBtn);
		
		$fieldColor = new Selectbox('color_scheme');
		$fieldColor->setLabel($lang->text('smwidgets', 'color_scheme_label'));
		$fieldColor->setDescription($lang->text('smwidgets', 'color_scheme_desc'));
		$fieldColor->setOptions(array('light' => $lang->text('smwidgets', 'admin_option_light'), 'dark' => $lang->text('smwidgets', 'admin_option_dark')));
		$form->addElement($fieldColor);
		
        $submit = new Submit('submit');
        $submit->setValue($lang->text('smwidgets', 'save_btn_label'));
        $form->addElement($submit);

        if ( OW::getRequest()->isPost() && $form->isValid($_POST) ){
			
            $data = $form->getValues();
			
			$config->saveConfig('smwidgets', 'data_width', trim($data['data_width']));
			$config->saveConfig('smwidgets', 'data_height', trim($data['data_height']));
			$config->saveConfig('smwidgets', 'color_scheme', trim($data['color_scheme']));
			$config->saveConfig('smwidgets', 'show_btn', trim($data['show_btn']));
			
			OW::getFeedback()->info($lang->text('smwidgets', 'admin_successfully_saved'));

            $this->redirect();
        }
		
		$fieldWidth->setValue($width);		
		$fieldHeight->setValue($height);		
		$fieldBtn->setValue($btn);		
		$fieldColor->setValue($color);
		
        $this->addForm($form);
    }

    public function facebook()
    {
        $this->setPageTitle(OW::getLanguage()->text('smwidgets', 'smwidget_heading'));
		
        $form = new Form('facebook_settings');
		
		$config = OW::getConfig();
		$lang = OW::getLanguage();
		
		$faces = $config->getValue('smwidgets', 'fb_data_faces');
		$stream = $config->getValue('smwidgets', 'fb_data_stream');
		$border = $config->getValue('smwidgets', 'fb_show_border');
		$header = $config->getValue('smwidgets', 'fb_show_header');
		
		$fieldFace = new Selectbox('fb_data_faces');
		$fieldFace->setLabel($lang->text('smwidgets', 'fb_data_faces_label'));
		$fieldFace->setDescription($lang->text('smwidgets', 'fb_data_faces_desc'));
		$fieldFace->setOptions(array('true' => $lang->text('smwidgets', 'admin_option_true'), 'false' => $lang->text('smwidgets', 'admin_option_false')));
		$form->addElement($fieldFace);
		
		$fieldHeader = new Selectbox('fb_show_header');
		$fieldHeader->setLabel($lang->text('smwidgets', 'fb_show_header_label'));
		$fieldHeader->setDescription($lang->text('smwidgets', 'fb_show_header_desc'));
		$fieldHeader->setOptions(array('true' => $lang->text('smwidgets', 'admin_option_true'), 'false' => $lang->text('smwidgets', 'admin_option_false')));
		$form->addElement($fieldHeader);
		
		$fieldStream = new Selectbox('fb_data_stream');
		$fieldStream->setLabel($lang->text('smwidgets', 'fb_data_stream_label'));
		$fieldStream->setDescription($lang->text('smwidgets', 'fb_data_stream_desc'));
		$fieldStream->setOptions(array('true' => $lang->text('smwidgets', 'admin_option_true'), 'false' => $lang->text('smwidgets', 'admin_option_false')));
		$form->addElement($fieldStream);
		
		$fieldBorder = new Selectbox('fb_show_border');
		$fieldBorder->setLabel($lang->text('smwidgets', 'fb_show_border_label'));
		$fieldBorder->setDescription($lang->text('smwidgets', 'fb_show_border_desc'));
		$fieldBorder->setOptions(array('true' => $lang->text('smwidgets', 'admin_option_true'), 'false' => $lang->text('smwidgets', 'admin_option_false')));
		$form->addElement($fieldBorder);
		
        $submit = new Submit('submit');
        $submit->setValue($lang->text('smwidgets', 'save_btn_label'));
        $form->addElement($submit);

        if ( OW::getRequest()->isPost() && $form->isValid($_POST) ){
			
            $data = $form->getValues();
			
			$config->saveConfig('smwidgets', 'fb_data_faces', trim($data['fb_data_faces']));
			$config->saveConfig('smwidgets', 'fb_data_stream', trim($data['fb_data_stream']));
			$config->saveConfig('smwidgets', 'fb_show_border', trim($data['fb_show_border']));
			$config->saveConfig('smwidgets', 'fb_show_header', trim($data['fb_show_header']));
			
			OW::getFeedback()->info($lang->text('smwidgets', 'admin_successfully_saved'));

            $this->redirect();
        }
		
		$fieldFace->setValue($faces);		
		$fieldHeader->setValue($header);		
		$fieldStream->setValue($stream);		
		$fieldBorder->setValue($border);		
		
        $this->addForm($form);
    }
	
	public function twitter()
    {		
		$config = OW::getConfig();		
		$lang = OW::getLanguage();
		
		$links = $config->getValue('smwidgets', 'tw_link');
		
        $this->setPageTitle(OW::getLanguage()->text('smwidgets', 'smwidget_heading'));
		
		
        $form = new Form('twitter_settings');
		
		$fieldLink = new ColorField('tw_link');
        $fieldLink->setLabel($lang->text("smwidgets", "tw_link_label"));
        $fieldLink->setDescription($lang->text('smwidgets', 'tw_link_desc'));
		$form->addElement($fieldLink);
		
        $submit = new Submit('submit');
        $submit->setValue($lang->text('smwidgets', 'save_btn_label'));
        $form->addElement($submit);

        if ( OW::getRequest()->isPost() && $form->isValid($_POST) )
        {
            $data = $form->getValues();
			
			$config->saveConfig('smwidgets', 'tw_link', trim($data['tw_link']));
			
			OW::getFeedback()->info($lang->text('smwidgets', 'admin_successfully_saved'));
            
            $this->redirect();
        }
		
		$fieldLink->setValue($links);		
		
        $this->addForm($form);
    }
	
	public function google()
    {		
		$config = OW::getConfig();
		$lang = OW::getLanguage();
		
		$class = $config->getValue('smwidgets', 'class');
		$layout = $config->getValue('smwidgets', 'g_data_layout');
		$cover = $config->getValue('smwidgets', 'g_data_showcoverphoto');
		$tagline = $config->getValue('smwidgets', 'g_data_tagline');
		
        $this->setPageTitle(OW::getLanguage()->text('smwidgets', 'smwidget_heading'));
		
		$form = new Form('google_settings');
		
		$fieldClass = new Selectbox('class');
        $fieldClass->setLabel($lang->text("smwidgets", "class_label"));
        $fieldClass->setDescription($lang->text('smwidgets', 'class_desc'));
		$fieldClass->setOptions(array('person' => $lang->text('smwidgets', 'admin_option_person'), 'page' => $lang->text('smwidgets', 'admin_option_page')));
		$form->addElement($fieldClass);
		
		$fieldTagline = new Selectbox('g_data_tagline');
        $fieldTagline->setLabel($lang->text("smwidgets", "g_data_tagline_label"));
        $fieldTagline->setDescription($lang->text('smwidgets', 'g_data_tagline_desc'));
		$fieldTagline->setOptions(array('true' => $lang->text('smwidgets', 'admin_option_true'), 'false' => $lang->text('smwidgets', 'admin_option_false')));
		$form->addElement($fieldTagline);
		
		$fieldLayout = new Selectbox('g_data_layout');
        $fieldLayout->setLabel($lang->text("smwidgets", "g_data_layout_label"));
        $fieldLayout->setDescription($lang->text('smwidgets', 'g_data_layout_desc'));
		$fieldLayout->setOptions(array('portrait' => $lang->text('smwidgets', 'admin_option_portrait'), 'landscape' => $lang->text('smwidgets', 'admin_option_landscape')));
		$form->addElement($fieldLayout);
		
		$fieldCover = new Selectbox('g_data_showcoverphoto');
        $fieldCover->setLabel($lang->text("smwidgets", "g_data_showcoverphoto_label"));
        $fieldCover->setDescription($lang->text('smwidgets', 'g_data_showcoverphoto_desc'));
		$fieldCover->setOptions(array('true' => $lang->text('smwidgets', 'admin_option_true'), 'false' => $lang->text('smwidgets', 'admin_option_false')));
		$form->addElement($fieldCover);
		
        $submit = new Submit('submit');
        $submit->setValue($lang->text('smwidgets', 'save_btn_label'));
        $form->addElement($submit);

        if ( OW::getRequest()->isPost() && $form->isValid($_POST) )
        {
            $data = $form->getValues();
			
			$config->saveConfig('smwidgets', 'class', trim($data['class']));
			$config->saveConfig('smwidgets', 'g_data_layout', trim($data['g_data_layout']));
			$config->saveConfig('smwidgets', 'g_data_showcoverphoto', trim($data['g_data_showcoverphoto']));
			$config->saveConfig('smwidgets', 'g_data_tagline', trim($data['g_data_tagline']));
			
			OW::getFeedback()->info($lang->text('smwidgets', 'admin_successfully_saved'));
		
            $this->redirect();
        }
		
		$fieldClass->setValue($class);		
		$fieldTagline->setValue($tagline);		
		$fieldCover->setValue($cover);		
		$fieldLayout->setValue($layout);		
		
        $this->addForm($form);
		
    }
}