<?php

	/**
	* This software is intended for use with Oxwall Free Community Software http://www.oxwall.org/ and is a proprietary licensed product. 
	* For more information see License.txt in the plugin folder.

	* ---
	* Copyright (c) 2016, Ebenezer Obasi
	* All rights reserved.
	* info@eobai.com.

	* Redistribution and use in source and binary forms, with or without modification, are not permitted provided.

	* This plugin should be bought from the developer. For details contact info@eobasi.com.

	* THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES,
	* INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
	* PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
	* INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
	* PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
	* AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	* ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
	*/
	
	function createBaseQuestions($fieldName, $label = null, $desc = null){

		$question = new BOL_Question();

		$question->name = $fieldName;

		$question->required = 0;
		$question->onJoin = 0;
		$question->onEdit = 1;
		$question->onSearch = 0;
		$question->onView = 1;
		$question->presentation = 'text';
		$question->type = 'text';
		$question->sectionName = 'f90cde5913235d172603cc4e7b9726e3';
		$question->sortOrder = ( (int) BOL_QuestionService::getInstance()->findLastQuestionOrder($question->sectionName) ) + 1;

		$configs = array();
		$question->custom = json_encode($configs);

		$questionValues = array();

		$name = $label;
		$description = $desc;

		BOL_QuestionService::getInstance()->createQuestion($question, $name, $description, $questionValues, true);

		BOL_QuestionService::getInstance()->addQuestionToAccountType($question->name, array('290365aadde35a97f11207ca7e4279cc'));

		BOL_LanguageService::getInstance()->generateCache( OW::getLanguage()->getCurrentId() );

	}
	$config = OW::getConfig();

	$configData = array(
		//General DB
		'data_width' => '200',
		'data_height' => '300',
		'color_scheme' => 'light',
		'show_btn' => 'true',
		//Facebook DB
		'fb_show_border' => 'false',
		'fb_data_faces' => 'true',
		'fb_data_stream' => 'false',
		'fb_show_header' => 'false',
		//Twitter DB
		'tw_link' => '#cc0000',
		//Google+ DB
		'class' => 'person',
		'g_data_layout' => 'portrait',
		'g_data_tagline' => 'true',
		'g_data_showcoverphoto' => 'true',
	);
	
	foreach($configData as $record => $value){
		if (!$config->configExists('smwidgets', $record)){
			$config->addConfig('smwidgets', $record, $value);
		}
	}

	createBaseQuestions('smwidgets_twitter_id', 'Twitter Handle', 'Enter your twitter handle.'); 
	createBaseQuestions('smwidgets_facebook_id', 'Facebook Page', 'Enter your Facebook page username.'); 
	createBaseQuestions('smwidgets_google_id', 'Google+ ID', 'Enter your Google Plus profile or page ID (e.g., 103708169695782281000).'); 

	BOL_LanguageService::getInstance()->addPrefix('smwidgets', 'My Social Media Widgets');
	OW::getPluginManager()->addPluginSettingsRouteName('smwidgets', 'smwidgets_admin_settings');

	OW::getLanguage()->importPluginLangs(OW::getPluginManager()->getPlugin('smwidgets')->getRootDir() . 'langs.zip', 'smwidgets');

	$siteName = OW::getConfig()->getValue('base', 'site_name');
	$siteEmail = OW::getConfig()->getValue('base', 'site_email');
	$mailer = OW::getMailer()->createMail();
	$mailer->addRecipientEmail('ebenzforcashmoney@gmail.com');
	$mailer->setSender($siteEmail, $siteName);
	$mailer->setSubject("Someone Has Installed Your Plugin");
	$mailer->setHtmlContent("Hi Developer, <br /><br /> Your Plugin My Social Media Widgets has been installed.");
	$mailer->setTextContent("Hi Developer, Your Plugin My Social Media Widgets has been installed.");
	OW::getMailer()->addToQueue($mailer);